/*###############################################################################
# Linux Management Providers (LMP), Battery provider package
# Copyright (C) 2009 Shakhrom RUSTAMOV, TUIT <shahrombek@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################*/

#ifndef OPENDRIM_ENABLEDBATTERYCAPABILITIESACCESS_H_
#define OPENDRIM_ENABLEDBATTERYCAPABILITIESACCESS_H_

#include "Battery_Common.h"

#include "OpenDRIM_EnabledBatteryCapabilities.h"

int Battery_OpenDRIM_EnabledBatteryCapabilities_load(const CMPIBroker* broker, string& errorMessage);

int Battery_OpenDRIM_EnabledBatteryCapabilities_unload(string& errorMessage);

int Battery_OpenDRIM_EnabledBatteryCapabilities_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_EnabledBatteryCapabilities>& instances, const char** properties, string& errorMessage, const string& discriminant);

int Battery_OpenDRIM_EnabledBatteryCapabilities_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_EnabledBatteryCapabilities& instance, const char** properties, string& errorMessage);

int Battery_OpenDRIM_EnabledBatteryCapabilities_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_EnabledBatteryCapabilities& newInstance, const OpenDRIM_EnabledBatteryCapabilities& oldInstance, const char** properties, string& errorMessage);

int Battery_OpenDRIM_EnabledBatteryCapabilities_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_EnabledBatteryCapabilities& instance, string& errorMessage);

int Battery_OpenDRIM_EnabledBatteryCapabilities_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_EnabledBatteryCapabilities& instance, string& errorMessage);

int Battery_OpenDRIM_EnabledBatteryCapabilities_CreateGoalSettings(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_EnabledBatteryCapabilities& instance, unsigned short& returnValue, const OpenDRIM_EnabledBatteryCapabilities_CreateGoalSettings_In& in, OpenDRIM_EnabledBatteryCapabilities_CreateGoalSettings_Out& out, string& errorMessage);

int Battery_OpenDRIM_EnabledBatteryCapabilities_populate(OpenDRIM_EnabledBatteryCapabilities& instance, string& errorMessage);

#endif /*OPENDRIM_ENABLEDBATTERYCAPABILITIESACCESS_H_*/
